/* adagio.h -- basic event data structure for Adagio
 *
 * JMaloney: made nline, ndur short to save space
 *			 separated nvoice and ncontroller
 */

#define name_length 255

#define minpitch -12
#define maxpitch 115
#define NO_PITCH (maxpitch+1)

#define minprogram 1
#define maxprogram 128

struct note_struct {
	ushort ndur;		/* duration */
	char npitch;		/* pitch (middle C = 48) */
	byte nloud;			/* loudness (MIDI velocity) */
	byte nprogram;		/* adagio Z parameter (MIDI program) */
};

struct ctrl_struct {
	byte value;
};

typedef struct event_struct {
	struct event_struct *next;
	ulong ntime;	/* start time */
	ushort nline;	/* line number from source code */
	byte nvoice;	/* adagio voice (MIDI Channel) */
	byte ncontroller;	/* controller number
								 * if non-zero, this is a control change
								 *	 for controller number 'ncontroller'
								 * otherwise this is a note */
	union {
		struct note_struct note;
		struct ctrl_struct ctrl;
	} u;
} *event_type;

#define nctrl 7
#define ctrlsize ((sizeof(struct event_struct) - \
		  sizeof(struct note_struct)) + sizeof(struct ctrl_struct))
#define is_note(n) (((n)->ncontroller) == 0)
