/* userio.h -- handy user-interface utilities */

#ifndef stdin
/* get definition of FILE */
#include <StdIO.h>
#endif

/* possible stop reasons */
#define CONTINUE			0
#define STOP_REQ			1
#define OUT_OF_MEMORY		2
#define PAUSE				3
#define END_SCORE			4

/* classes of output for gprintf */
#define TRANS	(Pointer)	0
#define ERROR	(Pointer)	1
#define FATAL	(Pointer)	2

void	abort_check(void);		/* call clean_exit if aborted flag is set */
boolean	askbool(char *query, boolean defltAnswer);
								/* asks user a yes/no question */
void	clean_exit(void);		/* exit after calling musicterm to clean up) */
void	cleanup_abort_handler(void);
								/* cleans up abort handler */
void	clear_abort(void);		/* clears the abort flag */
FILE *	fileopen(char *deflt, char *extension, char *mode, char *prompt);
								/* prompt for name and open a file */
boolean	get_ascii(int *ch);		/* polls for an ascii character */
void	gprintf(Pointer class, char *format, ...);	/* general printf */
void	init_abort_handler(void); /* sets up abort handler */
int		stop(void);				/* returns a stop condition, if any */
int		wait_ascii(void);		/* a waiting version of get_ascii */
